
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Future;
import static java.util.concurrent.Executors.newFixedThreadPool;

public class ProfilingAddition {

// test results on laptop i7 processor (two cores with hyperthreading)    
// Threads 1 with time: 29543
// Threads 2 with time: 21013
// Threads 3 with time: 15100
// Threads 4 with time: 14075
// Threads 5 with time: 14347
// Threads 10 with time: 13265    
    
    public static void main(String[] args) {

        ProfilingAddition tP = new ProfilingAddition();
        List<String> results = new ArrayList<>();

        results.add(tP.test(1));
        results.add(tP.test(2));
        results.add(tP.test(3));
        results.add(tP.test(4));
        results.add(tP.test(5));
        results.add(tP.test(10));

        for (String result : results) {
            System.out.println(result);
        }

    }

    ExecutorService threadPool;

    public String test(int numberOfThreads) {

        threadPool = newFixedThreadPool(numberOfThreads);
        List<Future> futures = new ArrayList<>();
        long time = System.currentTimeMillis();

        for (int i = 1; i <= 10; i++) {
            Callable<String> aCallable = new CallableImpl(i);
            Future<String> submit = threadPool.submit(aCallable);
            futures.add(submit);
        }

        try {
            for (Future future : futures) {
                System.out.println(future.get());
            }
        } catch (Exception ex) {
            System.out.println("Not ready ?? ...");
        }

        threadPool.shutdown(); // shutdown the pool.

        return ("Threads " + numberOfThreads + " with time: " + (System.currentTimeMillis() - time));

    }

    private class CallableImpl implements Callable<String> {

        String name;

        public CallableImpl(int number) {
            name = "Callable " + number;
        }

        @Override
        public String call() {
            Random random = new Random();
            Double result = 1.0;
            System.out.println(name + " is doing something");
            for (int j = 0; j < 100000000; j++) {
                result += random.nextDouble();
            }

            return name + " is " + result;
        }

    }

}
